#include "basin.h"

using namespace std;

int main( int argc, char *argv[] )
{
  /*
    This is a very simple demo to calculate pi using the Buffon-Laplace method.
    See the paper submitted for publication to 
    'Computing in Science and Engineering' for further discussion 
  */

  int myid,numprocs;
  /* 
     This is a simple basin function wrapping MPI initialize commands.
     Just for the user's convenience.
  */
  basin_initialize(myid,numprocs);



  /* 
     See the paper submitted to Computing in Science and Engineering for further 
     details on the algorithms and the meaning a,b,len 
  */

  double a=1.0;
  double b=1.0;
  double len=0.6;

  int count=0;

  Attribute phi,x,y;
  int numtrials=1000000;
  
  int seed1=1234;
  int seed2=4567;
  int seed3=7890;

  phi=2.*M_PI*attribute_random(numtrials,seed1);

  x=a*attribute_random(numtrials,seed2)+len*cos(phi);
  y=b*attribute_random(numtrials,seed3)+len*sin(phi);

  /*Counting the number of times the logical statement  is true*/ 
  count=sum(x<=0 || x>=a || y<=0 || y>=b);

  /* bout is a basin command to 'cout' only on process 0*/

  bout<<"pi="<<(double)numtrials/count*(2*len*(a+b)-pow(len,2.0))/(a*b)<<endl;

  /* Again, just a basin command wrapping the MPI finalize commands */
  basin_finalize();
  return( 0 );
}


