#include "basin_config.h"

#ifndef _FFTW_COMPLEX_TYPE_H_
#define _FFTW_COMPLEX_TYPE_H_

// First check if we can use the actual fftw library definitions
// if so, use those definitions
#ifdef BASIN_HAVE_DFFTW //check for double prefix first
    #include <dfftw.h>
    #include <dfftw_mpi.h>
    #include <drfftw.h>
    #include <drfftw_mpi.h>
#else
    #ifdef BASIN_HAVE_FFTW //check without double prefix
        #include <fftw.h>
        #include <fftw_mpi.h>
        #include <rfftw.h>
        #include <rfftw_mpi.h>
    #else
        // The fftw and dfftw headers don't exist, so 
        // we will use our own defintion of fftw_complex
    
        #ifdef __cplusplus
        extern "C" {
        #endif
        
            // We will always define real to be a double
            typedef double fftw_real;
        
            typedef struct {
                fftw_real re, im;
            } fftw_complex;
        #define c_re(c) ((c).re)
        #define c_im(c) ((c).im)
        
            typedef fftw_complex FFTW_COMPLEX;
        }
    #endif //BASIN_HAVE_FFTW 
#endif //BASIN_HAVE_DFFTW
#endif //_FFTW_COMPLEX_TYPE_H_
