using namespace std;

vector<double> center_of_mass(Attribute &x, Attribute &y, Attribute &z, Attribute &m);
vector<double> center_of_mass_2d(Attribute &x, Attribute &y, Attribute &m);

bool compare_vector (const vector<double>* a, const vector<double>* b);

//Pass local copies of x, y, z, and m
double compute_local_density(vector<double> &x, vector<double> &y, vector<double> &z, vector<double> &m, const int currPart, const int k);

//Pass local copies of x, y, z, and m
double compute_local_density(double x[], double y[], double z[], double m[], const int currPart, const int npart, const int k, double MAX_DIST = 1.e10);

Attribute density_list(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, int neighbors = 6);

Attribute density_list_vector(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, int neighbors = 6);

vector<double> density_center(Attribute &x, Attribute &y, Attribute &z, Attribute &dens_list);

vector<double> density_center_maxpos(Attribute &x, Attribute &y, Attribute &z, Attribute &dens_list);

double core_radius(Attribute &x, Attribute &y, Attribute &z, Attribute &dens_list, vector<double> dens_center);

vector<vector<double> > radial_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &A, int nbins, double rmin, double rmax, string scale = "linear");

vector<vector<double> > radial_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &A, Attribute &filter, int nbins, double rmin, double rmax, vector<double> filter_range, string scale = "linear");

vector<vector<double> > density_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, int nbins, double rmin, double rmax, string compute = "mass", string scale = "linear");

vector<vector<double> > density_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, Attribute &filter, int nbins, double rmin, double rmax, vector<double> filter_range, string compute = "mass", string scale = "linear");

vector<vector<double> > disp_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &A, int nbins, double rmin, double rmax, string scale = "linear");

vector<vector<double> > disp_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &A, Attribute &filter, int nbins, double rmin, double rmax, vector<double> mass_range, string scale = "linear");

//if radii[i] < 0, results[i] = -1. and if radii[i] == 0., results[i] = 0.
vector<double> lag_rad(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, vector<double> radii);


//if radii[i] < 0, results[i] = -1. and if radii[i] == 0., results[i] = 0.
vector<vector<double> > lag_rad(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, vector<double> radii, vector<double> mass_range);

//if radii[i] < 0, results[i] = -1. and if radii[i] == 0., results[i] = 0.
vector<vector<double> > lag_rad(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, Attribute &filter, vector<double> radii, vector<double> filter_range);

//Make (n+1) x (n+1) copy of nxn matrix a and put all values in indices 1..n, 1..n (ignore first row and column)
void jacobi(vector<vector<double> > &a, int n,vector<double> &d,vector<vector<double> > &v,int *nrot);
  //double a[4][4],d[4],v[4][4];
  //int n, *nrot;

void shape(vector<double> &x, vector<double> &y, vector<double> &z, vector<double> &m_loc, double &ba, double &ca, double d);
  
vector<vector<double> > shape_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, int nbins, double rmin, double rmax, string scale = "linear");

vector<vector<double> > shape_profile(Attribute &x, Attribute &y, Attribute &z, Attribute &mass, Attribute &filter, int nbins, double rmin, double rmax, vector<double> mass_range, string scale = "linear");




